%module SyFi
%{
#include <SyFi.h>
#include <ginac/ginac.h>

using namespace GiNaC;
using namespace SyFi;



void setDigits (int a) {
        Digits = a;
}




%}

%feature("autodoc", "1");

%include cpp2py_exceptions.i

%include std_string.i
%include stl.i



namespace GiNaC{
%include ex.i
%include typemaps.i
}

namespace GiNaC{
  class exvector{};
  class lst{};
}

//%include <std_map.i>
//%template(ex_ex_map)  std::map<GiNaC::ex, GiNaC::ex, GiNaC::ex_is_less>;
//%template(ex_int_map) std::map<GiNaC::ex, int, GiNaC::ex_is_less>;





%include tools.h
%include Polygon.h
%include FE.h
%include LagrangeFE.h
%include Dof.h
%include CrouzeixRaviart.h
%include P0.h
%include RaviartThomas.h
%include DiscontinuousLagrangeFE.h
%include HermiteFE.h
%include Nedelec.h
%include Nedelec2Hdiv.h
%include Bubble.h
%include ElementComputations.h
%include ArnoldFalkWintherWeakSym.h
%include Robust.h





%extend GiNaC::lst{
  void append(GiNaC::ex& e) {
    self->append(e);
  }
  GiNaC::ex __getitem__(int i) {
    if ( i >= 0 && unsigned(i) <= (*self).nops()-1) {
       return (*self)[i];
    } else {
       cout << "Outside range of lst!\n";
       return DUMMY;
    }

  }

};




%extend GiNaC::exvector {
  void append(GiNaC::ex& e) {
    self->insert(self->end(), e);
  }
  GiNaC::ex __getitem__(int i) {
    if ( i >= 0 && unsigned(i) <= (*self).size()-1) {
       return (*self)[i];
    } else {
       cout << "Outside range of exvector!\n";
       return DUMMY;
    }

  }

};

void setDigits (int a);

//%pythoncode %{
//from pytools import *
//%}



