#ifndef CROUZEIXRAVIART_IS_INCLUDED
#define CROUZEIXRAVIART_IS_INCLUDED


#include "FE.h"

namespace SyFi {

class CrouzeixRaviart : public StandardFE {
    public: 
        CrouzeixRaviart(); 
        CrouzeixRaviart(Polygon& p, int order = 1); 
        virtual ~CrouzeixRaviart() {}

        void set(int order); 
        void set(Polygon& p);  
        void compute_basis_functions();  
        virtual int nbf() const; 
        virtual GiNaC::ex N(int i);  
        virtual GiNaC::ex dof(int i); 
}; 

class VectorCrouzeixRaviart : public StandardFE {
    protected: 
        int size; 
    public: 
        VectorCrouzeixRaviart(); 
        VectorCrouzeixRaviart(Polygon& p, int order = 1, int size = nsd); 
        virtual ~VectorCrouzeixRaviart() {}

        virtual void set(int order); 
        virtual void set(Polygon& p);  
        virtual void set_size(int size_);  
        virtual void compute_basis_functions();  
        virtual int nbf() const; 
        virtual GiNaC::ex N(int i);  
        virtual GiNaC::ex dof(int i); 
}; 

}


#endif 
