#ifndef LAGRANGEFE_IS_INCLUDED
#define LAGRANGEFE_IS_INCLUDED 

#include "FE.h"

namespace SyFi {

class LagrangeFE : public StandardFE {
    public: 
        LagrangeFE() {}
        LagrangeFE(Polygon& p, int order = 1);  
        virtual ~LagrangeFE() {}

        virtual void set(int order); 
        virtual void set(Polygon& p);  
        virtual void compute_basis_functions();  
        virtual int nbf() const; 
        virtual GiNaC::ex N(int i);  
        virtual GiNaC::ex dof(int i); 
}; 



class VectorLagrangeFE : public StandardFE {
    protected: 
        int size; 
    public: 
        VectorLagrangeFE() {}
        VectorLagrangeFE(Polygon& p, int order = 1, int size = nsd ); 
        ~VectorLagrangeFE() {}

        virtual void set(int order); 
        virtual void set(Polygon& p);  
        virtual void set_size(int size_);  
        virtual void compute_basis_functions();  
        virtual int nbf() const; 
        virtual GiNaC::ex N(int i);  
        virtual GiNaC::ex dof(int i); 
}; 

}

#endif
