#ifndef ROBUST_IS_INCLUDED
#define ROBUST_IS_INCLUDED


#include "FE.h"

namespace SyFi {

class Robust : public StandardFE {
    public: 
        Robust() {}
        Robust(Polygon& p, int order = 3);  
        virtual ~Robust() {}

        virtual void set(int order); 
        virtual void set(Polygon& p);  
        virtual void compute_basis_functions();  
        virtual int nbf() const; 
        virtual GiNaC::ex N(int i);  
        virtual GiNaC::ex dof(int i); 
}; 

}

#endif 
