/*
 * Generated by prototype function generate_code.
 */

#include "matrix_smallElasticity2D.hh"

#include <math.h>
#include <utility>
#include <map>
#include "ptv.h"
#include "DofT.h"
#include "Dof_ptv.h"
#include <ScalarFunction.h>
#include <VectorFunction.h>

using namespace std;
using namespace pycc;
void smallElasticity2D(std::map< std::pair<int,int>, double> & matrix,Dof_ptv & dof, int element, double pp0[2], double pp1[2], double pp2[2], double *u, int size) {
    const int nbf = 6;

    double x0 = pp0[0]; double y0 = pp0[1];
    double x1 = pp1[0]; double y1 = pp1[1];
    double x2 = pp2[0]; double y2 = pp2[1];
 
    double G00 = x1 - x0;
    double G01 = x2 - x0;
 
    double G10 = y1 - y0;
    double G11 = y2 - y0;
 
    double D = fabs(G00*G11-G01*G10);

    const double Jinv00 = 1.0/(G00*G11-G10*G01)*G11;
    const double Jinv01 = -1.0/(G00*G11-G10*G01)*G10;
    const double Jinv10 = -1.0/(G00*G11-G10*G01)*G01;
    const double Jinv11 = 1.0/(G00*G11-G10*G01)*G00;

    int    iidof[6];
    double idof0[3];
    idof0[0] = x0;
    idof0[1] = y0;
    idof0[2] = 0.0;
    ptv ipdof0(3,idof0);
    iidof[0] = dof.insert_dof(element,0,ipdof0);

    double idof1[3];
    idof1[0] = x0;
    idof1[1] = y0;
    idof1[2] = 1.0;
    ptv ipdof1(3,idof1);
    iidof[1] = dof.insert_dof(element,1,ipdof1);

    double idof2[3];
    idof2[0] = G00+x0;
    idof2[1] = G10+y0;
    idof2[2] = 0.0;
    ptv ipdof2(3,idof2);
    iidof[2] = dof.insert_dof(element,2,ipdof2);

    double idof3[3];
    idof3[0] = G00+x0;
    idof3[1] = G10+y0;
    idof3[2] = 1.0;
    ptv ipdof3(3,idof3);
    iidof[3] = dof.insert_dof(element,3,ipdof3);

    double idof4[3];
    idof4[0] = G01+x0;
    idof4[1] = y0+G11;
    idof4[2] = 0.0;
    ptv ipdof4(3,idof4);
    iidof[4] = dof.insert_dof(element,4,ipdof4);

    double idof5[3];
    idof5[0] = G01+x0;
    idof5[1] = y0+G11;
    idof5[2] = 1.0;
    ptv ipdof5(3,idof5);
    iidof[5] = dof.insert_dof(element,5,ipdof5);


    const double u0 = u[iidof[0]];
    const double u1 = u[iidof[1]];
    const double u2 = u[iidof[2]];
    const double u3 = u[iidof[3]];
    const double u4 = u[iidof[4]];
    const double u5 = u[iidof[5]];

    const double _s0 = D*Jinv11;
    const double _s1 = _s0*Jinv10;
    const double _s2 = _s1*mu;
    const double _s3 = (Jinv01*Jinv01);
    const double _s4 = D*_s3;
    const double _s5 = _s4*mu;
    const double _s6 = _s5+_s2;
    const double _s7 = (Jinv00*Jinv00);
    const double _s8 = _s7*D;
    const double _s9 = _s8*mu;
    const double _s10 = _s9+_s6;
    const double _s11 = _s4*lambda;
    const double _s12 = 5.0000000000000000e-01*_s11;
    const double _s13 = _s12+_s10;
    const double _s14 = _s8*lambda;
    const double _s15 = 5.0000000000000000e-01*_s14;
    const double _s16 = _s15+_s13;
    const double _s17 = (Jinv10*Jinv10);
    const double _s18 = D*_s17;
    const double _s19 = _s18*mu;
    const double _s20 = 5.0000000000000000e-01*_s19;
    const double _s21 = _s20+_s16;
    const double _s22 = Jinv00*D;
    const double _s23 = _s22*Jinv01;
    const double _s24 = _s23*lambda;
    const double _s25 = _s24+_s21;
    const double _s26 = (Jinv11*Jinv11);
    const double _s27 = D*_s26;
    const double _s28 = _s27*mu;
    const double _s29 = 5.0000000000000000e-01*_s28;
    const double _s30 = _s25+_s29;
    const double _s31 = _s23*mu;
    const double _s32 = 2.0000000000000000e+00*_s31;
    const double _s33 = _s32+_s30;
    const double _s34 = D*Jinv10;
    const double _s35 = _s34*Jinv01;
    const double _s36 = _s35*mu;
    const double _s37 = 5.0000000000000000e-01*_s36;
    const double _s38 = _s22*Jinv10;
    const double _s39 = _s38*lambda;
    const double _s40 = 5.0000000000000000e-01*_s39;
    const double _s41 = _s37+_s40;
    const double _s42 = _s35*lambda;
    const double _s43 = 5.0000000000000000e-01*_s42;
    const double _s44 = _s43+_s41;
    const double _s45 = _s38*mu;
    const double _s46 = 5.0000000000000000e-01*_s45;
    const double _s47 = _s46+_s44;
    const double _s48 = Jinv11*_s22;
    const double _s49 = _s48*lambda;
    const double _s50 = 5.0000000000000000e-01*_s49;
    const double _s51 = _s47+_s50;
    const double _s52 = _s48*mu;
    const double _s53 = 5.0000000000000000e-01*_s52;
    const double _s54 = _s53+_s51;
    const double _s55 = _s0*Jinv01;
    const double _s56 = _s55*mu;
    const double _s57 = 5.0000000000000000e-01*_s56;
    const double _s58 = _s54+_s57;
    const double _s59 = _s55*lambda;
    const double _s60 = 5.0000000000000000e-01*_s59;
    const double _s61 = _s60+_s58;
    const double _s62 = -5.0000000000000000e-01*_s2;
    const double _s63 = -_s9;
    const double _s64 = _s62+_s63;
    const double _s65 = -5.0000000000000000e-01*_s14;
    const double _s66 = _s65+_s64;
    const double _s67 = -5.0000000000000000e-01*_s19;
    const double _s68 = _s66+_s67;
    const double _s69 = -5.0000000000000000e-01*_s24;
    const double _s70 = _s69+_s68;
    const double _s71 = -_s31;
    const double _s72 = _s70+_s71;
    const double _s73 = -5.0000000000000000e-01*_s39;
    const double _s74 = -5.0000000000000000e-01*_s42;
    const double _s75 = _s74+_s73;
    const double _s76 = -5.0000000000000000e-01*_s45;
    const double _s77 = _s75+_s76;
    const double _s78 = -5.0000000000000000e-01*_s52;
    const double _s79 = _s78+_s77;
    const double _s80 = -_s5;
    const double _s81 = _s80+_s62;
    const double _s82 = -5.0000000000000000e-01*_s11;
    const double _s83 = _s82+_s81;
    const double _s84 = _s83+_s69;
    const double _s85 = -5.0000000000000000e-01*_s28;
    const double _s86 = _s84+_s85;
    const double _s87 = _s86+_s71;
    const double _s88 = -5.0000000000000000e-01*_s36;
    const double _s89 = -5.0000000000000000e-01*_s49;
    const double _s90 = _s89+_s88;
    const double _s91 = -5.0000000000000000e-01*_s56;
    const double _s92 = _s91+_s90;
    const double _s93 = -5.0000000000000000e-01*_s59;
    const double _s94 = _s92+_s93;
    const double _s95 = 2.0000000000000000e+00*_s2;
    const double _s96 = 5.0000000000000000e-01*_s5;
    const double _s97 = _s95+_s96;
    const double _s98 = 5.0000000000000000e-01*_s9;
    const double _s99 = _s98+_s97;
    const double _s100 = _s1*lambda;
    const double _s101 = _s99+_s100;
    const double _s102 = _s19+_s101;
    const double _s103 = _s18*lambda;
    const double _s104 = 5.0000000000000000e-01*_s103;
    const double _s105 = _s104+_s102;
    const double _s106 = _s28+_s105;
    const double _s107 = _s27*lambda;
    const double _s108 = 5.0000000000000000e-01*_s107;
    const double _s109 = _s108+_s106;
    const double _s110 = _s109+_s31;
    const double _s111 = _s73+_s88;
    const double _s112 = _s111+_s76;
    const double _s113 = _s89+_s112;
    const double _s114 = -_s2;
    const double _s115 = -5.0000000000000000e-01*_s9;
    const double _s116 = _s115+_s114;
    const double _s117 = -5.0000000000000000e-01*_s100;
    const double _s118 = _s117+_s116;
    const double _s119 = -_s19;
    const double _s120 = _s118+_s119;
    const double _s121 = -5.0000000000000000e-01*_s103;
    const double _s122 = _s120+_s121;
    const double _s123 = -5.0000000000000000e-01*_s31;
    const double _s124 = _s122+_s123;
    const double _s125 = _s74+_s78;
    const double _s126 = _s125+_s91;
    const double _s127 = _s126+_s93;
    const double _s128 = -5.0000000000000000e-01*_s5;
    const double _s129 = _s128+_s114;
    const double _s130 = _s117+_s129;
    const double _s131 = -_s28;
    const double _s132 = _s130+_s131;
    const double _s133 = -5.0000000000000000e-01*_s107;
    const double _s134 = _s133+_s132;
    const double _s135 = _s134+_s123;
    const double _s136 = _s15+_s9;
    const double _s137 = _s20+_s136;
    const double _s138 = _s46+_s40;
    const double _s139 = 5.0000000000000000e-01*_s2;
    const double _s140 = 5.0000000000000000e-01*_s24;
    const double _s141 = _s140+_s139;
    const double _s142 = _s141+_s31;
    const double _s143 = _s37+_s50;
    const double _s144 = _s98+_s19;
    const double _s145 = _s104+_s144;
    const double _s146 = _s43+_s53;
    const double _s147 = 5.0000000000000000e-01*_s100;
    const double _s148 = _s147+_s2;
    const double _s149 = 5.0000000000000000e-01*_s31;
    const double _s150 = _s149+_s148;
    const double _s151 = _s12+_s5;
    const double _s152 = _s151+_s29;
    const double _s153 = _s60+_s57;
    const double _s154 = _s28+_s96;
    const double _s155 = _s154+_s108;
    double A[nbf][nbf];
    A[0][0] = _s33;
    A[1][0] = _s61;
    A[2][0] = _s72;
    A[3][0] = _s79;
    A[4][0] = _s87;
    A[5][0] = _s94;
    A[0][1] = _s61;
    A[1][1] = _s110;
    A[2][1] = _s113;
    A[3][1] = _s124;
    A[4][1] = _s127;
    A[5][1] = _s135;
    A[0][2] = _s72;
    A[1][2] = _s113;
    A[2][2] = _s137;
    A[3][2] = _s138;
    A[4][2] = _s142;
    A[5][2] = _s143;
    A[0][3] = _s79;
    A[1][3] = _s124;
    A[2][3] = _s138;
    A[3][3] = _s145;
    A[4][3] = _s146;
    A[5][3] = _s150;
    A[0][4] = _s87;
    A[1][4] = _s127;
    A[2][4] = _s142;
    A[3][4] = _s146;
    A[4][4] = _s152;
    A[5][4] = _s153;
    A[0][5] = _s94;
    A[1][5] = _s135;
    A[2][5] = _s143;
    A[3][5] = _s150;
    A[4][5] = _s153;
    A[5][5] = _s155;

    pair<int,int> index;
    for (int i=0; i< nbf; i++) {
        index.first = iidof[i];
        for (int j=0; j< nbf; j++) {
            index.second = iidof[j];
            matrix[index] += A[i][j];
        }
    }
}
