/*
 * Generated by prototype function generate_code.
 */

#include "matrix_stiffness.hh"

#include <math.h>
#include <utility>
#include <map>
#include "ptv.h"
#include "DofT.h"
#include <ScalarFunction.h>
#include <VectorFunction.h>

using namespace std
using namespace pycc;
void stiffness(std::map< std::pair<int,int>, double> & matrix,DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]) {
    double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];
    double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];
    double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];
    double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];
 
    double G00 = x1 - x0;
    double G10 = y1 - y0;
    double G20 = z1 - z0;
 
    double G01 = x2 - x0;
    double G11 = y2 - y0;
    double G21 = z2 - z0;
 
    double G02 = x3 - x0;
    double G12 = y3 - y0;
    double G22 = z3 - z0;
 
    double D =  G00*(G11*G22-G21*G12)
              - G01*(G10*G22-G20*G12)
              + G02*(G10*G21-G20*G11);


    const double Jinv00 = G11/(G11*G00-G10*G01);
    const double Jinv01 = -G10/(G11*G00-G10*G01);
    const double Jinv10 = -1.0/(G11*G00-G10*G01)*G01;
    const double Jinv11 = 1.0/(G11*G00-G10*G01)*G00;
    int    iidof[6];
    double idof0[3];
    idof0[0] = y0*G01+x0*G00+y0;
    idof0[1] = y0*G11+G10*x0;

    idof0[2] = 0.0;

    ptv ipdof0(3,idof0);
    iidof[0] = dof.insert_dof(element,0,ipdof0);

    double idof1[3];
    idof1[0] = y0*G01+x0*G00+y0;
    idof1[1] = y0*G11+G10*x0;

    idof1[2] = 1.0;

    ptv ipdof1(3,idof1);
    iidof[1] = dof.insert_dof(element,1,ipdof1);

    double idof2[3];
    idof2[0] = G01*y1+x1*G00+y0;
    idof2[1] = x1*G10+G11*y1;

    idof2[2] = 0.0;

    ptv ipdof2(3,idof2);
    iidof[2] = dof.insert_dof(element,2,ipdof2);

    double idof3[3];
    idof3[0] = G01*y1+x1*G00+y0;
    idof3[1] = x1*G10+G11*y1;

    idof3[2] = 1.0;

    ptv ipdof3(3,idof3);
    iidof[3] = dof.insert_dof(element,3,ipdof3);

    double idof4[3];
    idof4[0] = y2*G01+y0+G00*x2;
    idof4[1] = G11*y2+G10*x2;

    idof4[2] = 0.0;

    ptv ipdof4(3,idof4);
    iidof[4] = dof.insert_dof(element,4,ipdof4);

    double idof5[3];
    idof5[0] = y2*G01+y0+G00*x2;
    idof5[1] = G11*y2+G10*x2;

    idof5[2] = 1.0;

    ptv ipdof5(3,idof5);
    iidof[5] = dof.insert_dof(element,5,ipdof5);


    const double _s0 = x0*y1;
    const double _s1 = -_s0;
    const double _s2 = x1*y2;
    const double _s3 = -_s2;
    const double _s4 = _s1+_s3;
    const double _s5 = y2*x0;
    const double _s6 = _s4+_s5;
    const double _s7 = y0*x2;
    const double _s8 = -_s7;
    const double _s9 = _s6+_s8;
    const double _s10 = x1*y0;
    const double _s11 = _s9+_s10;
    const double _s12 = x2*y1;
    const double _s13 = _s12+_s11;
    const double _s14 = Jinv11*_s13;
    const double _s15 = Jinv10*_s14;
    const double _s16 = D*_s15;
    const double _s17 = _s16*x2;
    const double _s18 = _s17*y1;
    const double _s19 = -y0;
    const double _s20 = _s19+y1;
    const double _s21 = -x0;
    const double _s22 = _s21+x2;
    const double _s23 = _s22*_s20;
    const double _s24 = -_s23;
    const double _s25 = x1+_s21;
    const double _s26 = _s19+y2;
    const double _s27 = _s26*_s25;
    const double _s28 = _s24+_s27;
    const double _s29 = fabs(_s28);
    const double _s30 = _s29*_s18;
    const double _s31 = (Jinv10*Jinv10);
    const double _s32 = _s31*_s13;
    const double _s33 = _s32*y2;
    const double _s34 = D*_s33;
    const double _s35 = _s34*y1;
    const double _s36 = _s29*_s35;
    const double _s37 = -_s36;
    const double _s38 = _s30+_s37;
    const double _s39 = _s32*D;
    const double _s40 = (y1*y1);
    const double _s41 = _s40*_s39;
    const double _s42 = _s29*_s41;
    const double _s43 = 5.0000000000000000e-01*_s42;
    const double _s44 = _s38+_s43;
    const double _s45 = x1*_s13;
    const double _s46 = _s45*Jinv01;
    const double _s47 = Jinv00*_s46;
    const double _s48 = _s47*D;
    const double _s49 = _s48*y1;
    const double _s50 = _s29*_s49;
    const double _s51 = -_s50;
    const double _s52 = _s44+_s51;
    const double _s53 = (Jinv11*Jinv11);
    const double _s54 = _s13*_s53;
    const double _s55 = _s54*D;
    const double _s56 = (x2*x2);
    const double _s57 = _s56*_s55;
    const double _s58 = _s29*_s57;
    const double _s59 = 5.0000000000000000e-01*_s58;
    const double _s60 = _s52+_s59;
    const double _s61 = (Jinv00*Jinv00);
    const double _s62 = _s13*_s61;
    const double _s63 = _s62*D;
    const double _s64 = _s63*_s40;
    const double _s65 = _s29*_s64;
    const double _s66 = 5.0000000000000000e-01*_s65;
    const double _s67 = _s66+_s60;
    const double _s68 = Jinv01*_s13;
    const double _s69 = Jinv00*_s68;
    const double _s70 = _s69*D;
    const double _s71 = _s70*x2;
    const double _s72 = _s71*y1;
    const double _s73 = _s29*_s72;
    const double _s74 = _s73+_s67;
    const double _s75 = _s62*y2;
    const double _s76 = _s75*D;
    const double _s77 = _s76*y1;
    const double _s78 = _s29*_s77;
    const double _s79 = -_s78;
    const double _s80 = _s79+_s74;
    const double _s81 = (Jinv01*Jinv01);
    const double _s82 = _s81*_s13;
    const double _s83 = _s82*D;
    const double _s84 = _s56*_s83;
    const double _s85 = _s29*_s84;
    const double _s86 = 5.0000000000000000e-01*_s85;
    const double _s87 = _s80+_s86;
    const double _s88 = (x1*x1);
    const double _s89 = _s88*_s13;
    const double _s90 = _s81*_s89;
    const double _s91 = _s90*D;
    const double _s92 = _s29*_s91;
    const double _s93 = 5.0000000000000000e-01*_s92;
    const double _s94 = _s87+_s93;
    const double _s95 = x1*_s15;
    const double _s96 = _s95*D;
    const double _s97 = _s96*y1;
    const double _s98 = _s29*_s97;
    const double _s99 = -_s98;
    const double _s100 = _s94+_s99;
    const double _s101 = _s69*y2;
    const double _s102 = _s101*D;
    const double _s103 = _s102*x2;
    const double _s104 = _s29*_s103;
    const double _s105 = -_s104;
    const double _s106 = _s100+_s105;
    const double _s107 = x1*_s54;
    const double _s108 = _s107*D;
    const double _s109 = _s108*x2;
    const double _s110 = _s29*_s109;
    const double _s111 = -_s110;
    const double _s112 = _s106+_s111;
    const double _s113 = (y2*y2);
    const double _s114 = _s113*_s62;
    const double _s115 = _s114*D;
    const double _s116 = _s29*_s115;
    const double _s117 = 5.0000000000000000e-01*_s116;
    const double _s118 = _s117+_s112;
    const double _s119 = _s47*y2;
    const double _s120 = _s119*D;
    const double _s121 = _s29*_s120;
    const double _s122 = _s118+_s121;
    const double _s123 = _s88*_s54;
    const double _s124 = _s123*D;
    const double _s125 = _s29*_s124;
    const double _s126 = 5.0000000000000000e-01*_s125;
    const double _s127 = _s126+_s122;
    const double _s128 = _s113*_s32;
    const double _s129 = _s128*D;
    const double _s130 = _s29*_s129;
    const double _s131 = 5.0000000000000000e-01*_s130;
    const double _s132 = _s131+_s127;
    const double _s133 = _s81*_s45;
    const double _s134 = _s133*D;
    const double _s135 = _s134*x2;
    const double _s136 = _s135*_s29;
    const double _s137 = -_s136;
    const double _s138 = _s132+_s137;
    const double _s139 = y2*_s15;
    const double _s140 = D*_s139;
    const double _s141 = _s140*x2;
    const double _s142 = _s29*_s141;
    const double _s143 = -_s142;
    const double _s144 = _s138+_s143;
    const double _s145 = y2*_s95;
    const double _s146 = _s145*D;
    const double _s147 = _s29*_s146;
    const double _s148 = _s147+_s144;
    const double _s149 = y0*_s13;
    const double _s150 = _s149*_s61;
    const double _s151 = D*_s150;
    const double _s152 = _s151*y1;
    const double _s153 = _s29*_s152;
    const double _s154 = -5.0000000000000000e-01*_s153;
    const double _s155 = -5.0000000000000000e-01*_s30;
    const double _s156 = _s155+_s154;
    const double _s157 = _s69*x0;
    const double _s158 = _s157*D;
    const double _s159 = _s158*y1;
    const double _s160 = _s29*_s159;
    const double _s161 = 5.0000000000000000e-01*_s160;
    const double _s162 = _s161+_s156;
    const double _s163 = 5.0000000000000000e-01*_s36;
    const double _s164 = _s163+_s162;
    const double _s165 = _s107*x0;
    const double _s166 = _s165*D;
    const double _s167 = _s29*_s166;
    const double _s168 = -5.0000000000000000e-01*_s167;
    const double _s169 = _s164+_s168;
    const double _s170 = x0*_s101;
    const double _s171 = _s170*D;
    const double _s172 = _s29*_s171;
    const double _s173 = -5.0000000000000000e-01*_s172;
    const double _s174 = _s173+_s169;
    const double _s175 = -5.0000000000000000e-01*_s58;
    const double _s176 = _s174+_s175;
    const double _s177 = -5.0000000000000000e-01*_s73;
    const double _s178 = _s176+_s177;
    const double _s179 = _s32*y0;
    const double _s180 = _s179*D;
    const double _s181 = _s180*y1;
    const double _s182 = _s29*_s181;
    const double _s183 = -5.0000000000000000e-01*_s182;
    const double _s184 = _s183+_s178;
    const double _s185 = x0*_s15;
    const double _s186 = _s185*D;
    const double _s187 = _s186*y1;
    const double _s188 = _s29*_s187;
    const double _s189 = 5.0000000000000000e-01*_s188;
    const double _s190 = _s189+_s184;
    const double _s191 = 5.0000000000000000e-01*_s78;
    const double _s192 = _s191+_s190;
    const double _s193 = -5.0000000000000000e-01*_s85;
    const double _s194 = _s193+_s192;
    const double _s195 = x0*_s139;
    const double _s196 = _s195*D;
    const double _s197 = _s29*_s196;
    const double _s198 = -5.0000000000000000e-01*_s197;
    const double _s199 = _s198+_s194;
    const double _s200 = x0*_s133;
    const double _s201 = _s200*D;
    const double _s202 = _s201*_s29;
    const double _s203 = -5.0000000000000000e-01*_s202;
    const double _s204 = _s199+_s203;
    const double _s205 = x0*_s82;
    const double _s206 = _s205*D;
    const double _s207 = _s206*x2;
    const double _s208 = _s29*_s207;
    const double _s209 = 5.0000000000000000e-01*_s208;
    const double _s210 = _s204+_s209;
    const double _s211 = _s104+_s210;
    const double _s212 = y2*_s150;
    const double _s213 = _s212*D;
    const double _s214 = _s29*_s213;
    const double _s215 = 5.0000000000000000e-01*_s214;
    const double _s216 = _s211+_s215;
    const double _s217 = 5.0000000000000000e-01*_s110;
    const double _s218 = _s216+_s217;
    const double _s219 = _s45*y0;
    const double _s220 = _s219*Jinv01;
    const double _s221 = Jinv00*_s220;
    const double _s222 = _s221*D;
    const double _s223 = _s29*_s222;
    const double _s224 = 5.0000000000000000e-01*_s223;
    const double _s225 = _s218+_s224;
    const double _s226 = y0*_s15;
    const double _s227 = _s226*D;
    const double _s228 = _s227*x2;
    const double _s229 = _s29*_s228;
    const double _s230 = -5.0000000000000000e-01*_s229;
    const double _s231 = _s225+_s230;
    const double _s232 = -5.0000000000000000e-01*_s116;
    const double _s233 = _s231+_s232;
    const double _s234 = -5.0000000000000000e-01*_s121;
    const double _s235 = _s233+_s234;
    const double _s236 = x0*_s54;
    const double _s237 = D*_s236;
    const double _s238 = _s237*x2;
    const double _s239 = _s29*_s238;
    const double _s240 = 5.0000000000000000e-01*_s239;
    const double _s241 = _s235+_s240;
    const double _s242 = -5.0000000000000000e-01*_s130;
    const double _s243 = _s241+_s242;
    const double _s244 = _s179*y2;
    const double _s245 = _s244*D;
    const double _s246 = _s29*_s245;
    const double _s247 = 5.0000000000000000e-01*_s246;
    const double _s248 = _s247+_s243;
    const double _s249 = 5.0000000000000000e-01*_s136;
    const double _s250 = _s248+_s249;
    const double _s251 = y0*_s95;
    const double _s252 = _s251*D;
    const double _s253 = _s29*_s252;
    const double _s254 = 5.0000000000000000e-01*_s253;
    const double _s255 = _s254+_s250;
    const double _s256 = _s142+_s255;
    const double _s257 = Jinv01*_s149;
    const double _s258 = _s257*Jinv00;
    const double _s259 = _s258*D;
    const double _s260 = _s259*x2;
    const double _s261 = _s29*_s260;
    const double _s262 = -5.0000000000000000e-01*_s261;
    const double _s263 = _s256+_s262;
    const double _s264 = -5.0000000000000000e-01*_s147;
    const double _s265 = _s263+_s264;
    const double _s266 = 5.0000000000000000e-01*_s153;
    const double _s267 = _s266+_s155;
    const double _s268 = -5.0000000000000000e-01*_s160;
    const double _s269 = _s267+_s268;
    const double _s270 = _s269+_s163;
    const double _s271 = -5.0000000000000000e-01*_s42;
    const double _s272 = _s270+_s271;
    const double _s273 = _s50+_s272;
    const double _s274 = 5.0000000000000000e-01*_s167;
    const double _s275 = _s273+_s274;
    const double _s276 = 5.0000000000000000e-01*_s172;
    const double _s277 = _s275+_s276;
    const double _s278 = -5.0000000000000000e-01*_s65;
    const double _s279 = _s277+_s278;
    const double _s280 = _s279+_s177;
    const double _s281 = 5.0000000000000000e-01*_s182;
    const double _s282 = _s280+_s281;
    const double _s283 = -5.0000000000000000e-01*_s188;
    const double _s284 = _s282+_s283;
    const double _s285 = _s191+_s284;
    const double _s286 = -5.0000000000000000e-01*_s92;
    const double _s287 = _s285+_s286;
    const double _s288 = 5.0000000000000000e-01*_s197;
    const double _s289 = _s287+_s288;
    const double _s290 = 5.0000000000000000e-01*_s202;
    const double _s291 = _s289+_s290;
    const double _s292 = -5.0000000000000000e-01*_s208;
    const double _s293 = _s291+_s292;
    const double _s294 = _s293+_s98;
    const double _s295 = -5.0000000000000000e-01*_s214;
    const double _s296 = _s294+_s295;
    const double _s297 = _s296+_s217;
    const double _s298 = -5.0000000000000000e-01*_s223;
    const double _s299 = _s297+_s298;
    const double _s300 = 5.0000000000000000e-01*_s229;
    const double _s301 = _s299+_s300;
    const double _s302 = _s301+_s234;
    const double _s303 = -5.0000000000000000e-01*_s125;
    const double _s304 = _s302+_s303;
    const double _s305 = -5.0000000000000000e-01*_s239;
    const double _s306 = _s304+_s305;
    const double _s307 = -5.0000000000000000e-01*_s246;
    const double _s308 = _s306+_s307;
    const double _s309 = _s308+_s249;
    const double _s310 = -5.0000000000000000e-01*_s253;
    const double _s311 = _s309+_s310;
    const double _s312 = 5.0000000000000000e-01*_s261;
    const double _s313 = _s311+_s312;
    const double _s314 = _s313+_s264;
    const double _s315 = _s59+_s172;
    const double _s316 = x0*_s226;
    const double _s317 = _s316*D;
    const double _s318 = _s29*_s317;
    const double _s319 = -_s318;
    const double _s320 = _s319+_s315;
    const double _s321 = x0*_s258;
    const double _s322 = _s321*D;
    const double _s323 = _s29*_s322;
    const double _s324 = -_s323;
    const double _s325 = _s320+_s324;
    const double _s326 = _s325+_s86;
    const double _s327 = (y0*y0);
    const double _s328 = _s327*_s13;
    const double _s329 = _s328*_s61;
    const double _s330 = _s329*D;
    const double _s331 = _s29*_s330;
    const double _s332 = 5.0000000000000000e-01*_s331;
    const double _s333 = _s326+_s332;
    const double _s334 = _s333+_s197;
    const double _s335 = -_s208;
    const double _s336 = _s335+_s334;
    const double _s337 = _s336+_s105;
    const double _s338 = -_s214;
    const double _s339 = _s338+_s337;
    const double _s340 = _s32*_s327;
    const double _s341 = _s340*D;
    const double _s342 = _s29*_s341;
    const double _s343 = 5.0000000000000000e-01*_s342;
    const double _s344 = _s343+_s339;
    const double _s345 = _s229+_s344;
    const double _s346 = _s117+_s345;
    const double _s347 = -_s239;
    const double _s348 = _s347+_s346;
    const double _s349 = (x0*x0);
    const double _s350 = _s349*_s54;
    const double _s351 = D*_s350;
    const double _s352 = _s29*_s351;
    const double _s353 = 5.0000000000000000e-01*_s352;
    const double _s354 = _s353+_s348;
    const double _s355 = _s131+_s354;
    const double _s356 = -_s246;
    const double _s357 = _s356+_s355;
    const double _s358 = _s357+_s143;
    const double _s359 = _s349*_s82;
    const double _s360 = _s359*D;
    const double _s361 = _s29*_s360;
    const double _s362 = 5.0000000000000000e-01*_s361;
    const double _s363 = _s358+_s362;
    const double _s364 = _s261+_s363;
    const double _s365 = 5.0000000000000000e-01*_s30;
    const double _s366 = _s365+_s266;
    const double _s367 = _s268+_s366;
    const double _s368 = -5.0000000000000000e-01*_s36;
    const double _s369 = _s367+_s368;
    const double _s370 = _s369+_s274;
    const double _s371 = _s173+_s370;
    const double _s372 = _s371+_s318;
    const double _s373 = _s323+_s372;
    const double _s374 = 5.0000000000000000e-01*_s73;
    const double _s375 = _s373+_s374;
    const double _s376 = _s375+_s281;
    const double _s377 = _s376+_s283;
    const double _s378 = -5.0000000000000000e-01*_s78;
    const double _s379 = _s377+_s378;
    const double _s380 = -5.0000000000000000e-01*_s331;
    const double _s381 = _s380+_s379;
    const double _s382 = _s198+_s381;
    const double _s383 = _s290+_s382;
    const double _s384 = _s383+_s209;
    const double _s385 = _s384+_s215;
    const double _s386 = -5.0000000000000000e-01*_s110;
    const double _s387 = _s385+_s386;
    const double _s388 = _s298+_s387;
    const double _s389 = -5.0000000000000000e-01*_s342;
    const double _s390 = _s388+_s389;
    const double _s391 = _s390+_s230;
    const double _s392 = 5.0000000000000000e-01*_s121;
    const double _s393 = _s391+_s392;
    const double _s394 = _s393+_s240;
    const double _s395 = -5.0000000000000000e-01*_s352;
    const double _s396 = _s394+_s395;
    const double _s397 = _s247+_s396;
    const double _s398 = -5.0000000000000000e-01*_s136;
    const double _s399 = _s397+_s398;
    const double _s400 = _s399+_s310;
    const double _s401 = -5.0000000000000000e-01*_s361;
    const double _s402 = _s400+_s401;
    const double _s403 = _s402+_s262;
    const double _s404 = 5.0000000000000000e-01*_s147;
    const double _s405 = _s403+_s404;
    const double _s406 = -_s153;
    const double _s407 = _s160+_s406;
    const double _s408 = _s407+_s43;
    const double _s409 = _s408+_s51;
    const double _s410 = -_s167;
    const double _s411 = _s409+_s410;
    const double _s412 = _s411+_s319;
    const double _s413 = _s66+_s412;
    const double _s414 = _s413+_s324;
    const double _s415 = -_s182;
    const double _s416 = _s415+_s414;
    const double _s417 = _s188+_s416;
    const double _s418 = _s417+_s93;
    const double _s419 = _s418+_s332;
    const double _s420 = -_s202;
    const double _s421 = _s419+_s420;
    const double _s422 = _s421+_s99;
    const double _s423 = _s422+_s223;
    const double _s424 = _s423+_s343;
    const double _s425 = _s126+_s424;
    const double _s426 = _s353+_s425;
    const double _s427 = _s426+_s253;
    const double _s428 = _s427+_s362;
    double A[6][6];
    A[0][0] = _s148;
    A[0][1] = 0.0;
    A[0][2] = _s265;
    A[0][3] = 0.0;
    A[0][4] = _s314;
    A[0][5] = 0.0;
    A[1][0] = 0.0;
    A[1][1] = _s148;
    A[1][2] = 0.0;
    A[1][3] = _s265;
    A[1][4] = 0.0;
    A[1][5] = _s314;
    A[2][0] = _s265;
    A[2][1] = 0.0;
    A[2][2] = _s364;
    A[2][3] = 0.0;
    A[2][4] = _s405;
    A[2][5] = 0.0;
    A[3][0] = 0.0;
    A[3][1] = _s265;
    A[3][2] = 0.0;
    A[3][3] = _s364;
    A[3][4] = 0.0;
    A[3][5] = _s405;
    A[4][0] = _s314;
    A[4][1] = 0.0;
    A[4][2] = _s405;
    A[4][3] = 0.0;
    A[4][4] = _s428;
    A[4][5] = 0.0;
    A[5][0] = 0.0;
    A[5][1] = _s314;
    A[5][2] = 0.0;
    A[5][3] = _s405;
    A[5][4] = 0.0;
    A[5][5] = _s428;

    int nbf = fe.nbf();
    pair<int,int> index;
    for (int i=0; i< nbf; i++) {
        index.first = iidof[i];
        for (int j=0; j< nbf; j++) {
            index.second = iidof[j];
            matrix[index] += A[i][j];
        }
    }
}
